#[doc = "Register `XOSCCTRL` reader"]
pub type R = crate::R<XoscctrlSpec>;
#[doc = "Register `XOSCCTRL` writer"]
pub type W = crate::W<XoscctrlSpec>;
#[doc = "Field `ENABLE` reader - Oscillator Enable"]
pub type EnableR = crate::BitReader;
#[doc = "Field `ENABLE` writer - Oscillator Enable"]
pub type EnableW<'a, REG> = crate::BitWriter<'a, REG>;
#[doc = "Field `XTALEN` reader - Crystal Oscillator Enable"]
pub type XtalenR = crate::BitReader;
#[doc = "Field `XTALEN` writer - Crystal Oscillator Enable"]
pub type XtalenW<'a, REG> = crate::BitWriter<'a, REG>;
#[doc = "Field `CFDEN` reader - Xosc Clock Failure Detecteor Enable"]
pub type CfdenR = crate::BitReader;
#[doc = "Field `CFDEN` writer - Xosc Clock Failure Detecteor Enable"]
pub type CfdenW<'a, REG> = crate::BitWriter<'a, REG>;
#[doc = "Field `SWBEN` reader - Xosc Clock Switch Enable"]
pub type SwbenR = crate::BitReader;
#[doc = "Field `SWBEN` writer - Xosc Clock Switch Enable"]
pub type SwbenW<'a, REG> = crate::BitWriter<'a, REG>;
#[doc = "Field `RUNSTDBY` reader - Run in Standby"]
pub type RunstdbyR = crate::BitReader;
#[doc = "Field `RUNSTDBY` writer - Run in Standby"]
pub type RunstdbyW<'a, REG> = crate::BitWriter<'a, REG>;
#[doc = "Field `ONDEMAND` reader - On Demand Control"]
pub type OndemandR = crate::BitReader;
#[doc = "Field `ONDEMAND` writer - On Demand Control"]
pub type OndemandW<'a, REG> = crate::BitWriter<'a, REG>;
#[doc = "Field `GAIN` reader - Oscillator Gain"]
pub type GainR = crate::FieldReader;
#[doc = "Field `GAIN` writer - Oscillator Gain"]
pub type GainW<'a, REG> = crate::FieldWriter<'a, REG, 3>;
#[doc = "Field `AMPGC` reader - Automatic Amplitude Gain Control"]
pub type AmpgcR = crate::BitReader;
#[doc = "Field `AMPGC` writer - Automatic Amplitude Gain Control"]
pub type AmpgcW<'a, REG> = crate::BitWriter<'a, REG>;
#[doc = "Field `STARTUP` reader - Start-Up Time"]
pub type StartupR = crate::FieldReader;
#[doc = "Field `STARTUP` writer - Start-Up Time"]
pub type StartupW<'a, REG> = crate::FieldWriter<'a, REG, 4>;
impl R {
    #[doc = "Bit 1 - Oscillator Enable"]
    #[inline(always)]
    pub fn enable(&self) -> EnableR {
        EnableR::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - Crystal Oscillator Enable"]
    #[inline(always)]
    pub fn xtalen(&self) -> XtalenR {
        XtalenR::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - Xosc Clock Failure Detecteor Enable"]
    #[inline(always)]
    pub fn cfden(&self) -> CfdenR {
        CfdenR::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - Xosc Clock Switch Enable"]
    #[inline(always)]
    pub fn swben(&self) -> SwbenR {
        SwbenR::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 6 - Run in Standby"]
    #[inline(always)]
    pub fn runstdby(&self) -> RunstdbyR {
        RunstdbyR::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 7 - On Demand Control"]
    #[inline(always)]
    pub fn ondemand(&self) -> OndemandR {
        OndemandR::new(((self.bits >> 7) & 1) != 0)
    }
    #[doc = "Bits 8:10 - Oscillator Gain"]
    #[inline(always)]
    pub fn gain(&self) -> GainR {
        GainR::new(((self.bits >> 8) & 7) as u8)
    }
    #[doc = "Bit 11 - Automatic Amplitude Gain Control"]
    #[inline(always)]
    pub fn ampgc(&self) -> AmpgcR {
        AmpgcR::new(((self.bits >> 11) & 1) != 0)
    }
    #[doc = "Bits 12:15 - Start-Up Time"]
    #[inline(always)]
    pub fn startup(&self) -> StartupR {
        StartupR::new(((self.bits >> 12) & 0x0f) as u8)
    }
}
impl W {
    #[doc = "Bit 1 - Oscillator Enable"]
    #[inline(always)]
    pub fn enable(&mut self) -> EnableW<XoscctrlSpec> {
        EnableW::new(self, 1)
    }
    #[doc = "Bit 2 - Crystal Oscillator Enable"]
    #[inline(always)]
    pub fn xtalen(&mut self) -> XtalenW<XoscctrlSpec> {
        XtalenW::new(self, 2)
    }
    #[doc = "Bit 3 - Xosc Clock Failure Detecteor Enable"]
    #[inline(always)]
    pub fn cfden(&mut self) -> CfdenW<XoscctrlSpec> {
        CfdenW::new(self, 3)
    }
    #[doc = "Bit 4 - Xosc Clock Switch Enable"]
    #[inline(always)]
    pub fn swben(&mut self) -> SwbenW<XoscctrlSpec> {
        SwbenW::new(self, 4)
    }
    #[doc = "Bit 6 - Run in Standby"]
    #[inline(always)]
    pub fn runstdby(&mut self) -> RunstdbyW<XoscctrlSpec> {
        RunstdbyW::new(self, 6)
    }
    #[doc = "Bit 7 - On Demand Control"]
    #[inline(always)]
    pub fn ondemand(&mut self) -> OndemandW<XoscctrlSpec> {
        OndemandW::new(self, 7)
    }
    #[doc = "Bits 8:10 - Oscillator Gain"]
    #[inline(always)]
    pub fn gain(&mut self) -> GainW<XoscctrlSpec> {
        GainW::new(self, 8)
    }
    #[doc = "Bit 11 - Automatic Amplitude Gain Control"]
    #[inline(always)]
    pub fn ampgc(&mut self) -> AmpgcW<XoscctrlSpec> {
        AmpgcW::new(self, 11)
    }
    #[doc = "Bits 12:15 - Start-Up Time"]
    #[inline(always)]
    pub fn startup(&mut self) -> StartupW<XoscctrlSpec> {
        StartupW::new(self, 12)
    }
}
#[doc = "External Multipurpose Crystal Oscillator (XOSC) Control\n\nYou can [`read`](crate::Reg::read) this register and get [`xoscctrl::R`](R). You can [`reset`](crate::Reg::reset), [`write`](crate::Reg::write), [`write_with_zero`](crate::Reg::write_with_zero) this register using [`xoscctrl::W`](W). You can also [`modify`](crate::Reg::modify) this register. See [API](https://docs.rs/svd2rust/#read--modify--write-api)."]
pub struct XoscctrlSpec;
impl crate::RegisterSpec for XoscctrlSpec {
    type Ux = u16;
}
#[doc = "`read()` method returns [`xoscctrl::R`](R) reader structure"]
impl crate::Readable for XoscctrlSpec {}
#[doc = "`write(|w| ..)` method takes [`xoscctrl::W`](W) writer structure"]
impl crate::Writable for XoscctrlSpec {
    type Safety = crate::Unsafe;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: u16 = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: u16 = 0;
}
#[doc = "`reset()` method sets XOSCCTRL to value 0x80"]
impl crate::Resettable for XoscctrlSpec {
    const RESET_VALUE: u16 = 0x80;
}
